<?php

//PHPCIPHER NO ENCRYPT

  // Tell Logaholic about this parser type.
  
  // Needs these parameters: Description (text description), ClassName (modify for each parser) and, AutoDiscoverable - true/false - must currently be true.
	$log_parser_types[] = Array("order" => "12", "Description" => "Apache Vhosts Combined", "ClassName" => "ApacheVCombined", "AutoDiscoverable" => true);

	class ApacheVCombined extends GenericLogParser {
		
		var $scanEx;
		
		function Initialize($file) {
            $flogline=gzgets($file,5120);
            if (substr($flogline, 0, 1) =="#") {
                $this->lasterrormessage .= "# lines should not present in this format, aborting";
                return false;
            } else {
                
                
                // LogFormat "%V %h %l %u %t \"%r\" %s %b \"%{Referer}i\" \"%{User-Agent}i\"" vcombined

                //www.lesprosdelaboue.com cnq7-48.cablevision.qc.ca - - [19/Apr/2010:10:06:43 -0400] "GET /images/categories/ HTTP/1.1" 403 1106 "http://www.lesprosdelaboue.com/details.php?SKU=182" "Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.1; Trident/4.0; IE7-01NET.COM-1.1; GTB6.4; .NET CLR 1.1.4322; .NET CLR 2.0.50727; .NET CLR 3.0.04506.30; InfoPath.2; 3P_UVRM 1.0.22.0; OfficeLiveConnector.1.3; OfficeLivePatch.0.0; msn OptimizedIE8;FRCA)"
                
			    $this->scanEx = '%s %s %s %s [%[^]]] "%s %s %[^"]" %d %s "%[^"]" "%[^"]"';
			    return true;
            }
		}
		
		function ParseLine($line) {
            global $profile;
            global $equivdomains, $equivalent_domains_regex;
			
            /*
            $log['vhost']   0
            $log['ip'],     1
            $log['client'],       2
            $log['user'],          3
            $log['time'],           4
            $log['method'],          5
            $log['uri'],              6
            $log['prot'],              7
            $log['code'],               8
            $log['bytes'],               9
            $log['ref'],                  10
            $log['agent']                  11
             */
			if ($matches= sscanf($line, $this->scanEx)) {
              
              //skip the lines that don't match the host name we're interested in 
              $isEquivalent = true;  
              if ($profile->confdomain != $matches[0] && !in_array($matches[0], $equivdomains)) {                  
                  $isEquivalent = false;                      
              }
              foreach ($equivalent_domains_regex as $thisregex) {
                    if (preg_match("/".$thisregex."/i", $matches[0])) {
                        $isEquivalent = true;
                        break;
                    }
              }
              if ($isEquivalent == false) {
                    $this->lastlineisdata = false;
                    return true;    
              }
              
              // analyze the line
              $this->clientip = $matches[1];                 
              $long = ip2long($this->clientip);

              if ($long == -1 || $long === FALSE) {
                   return false;
              }
              $this->authuser = $matches[3];
              // We're explicitly ignoring the time offset stored in the log here, for legacy reasons and because 
              // all the implications of time zone handling...
              $logtimeq=str_replace("/", " ", substr($matches[4],0,11)) . " " . substr($matches[4],12,8);
              $this->logdate = strtotime($logtimeq);
              $this->reqfile = $matches[6];
              $this->status = $matches[8];
              $this->bytes = $matches[9];
              if ($this->bytes == "-") {
                  $this->bytes = 0;
                }
              $this->referrer = $matches[10];
              $this->agent = $matches[11];
              $this->cookie = "";
              $this->lastlineisdata = true;
              return true;
            } else {
              $this->lastlineisdata = false;
              $this->lasterrormessage = "Unparseable log line:<br><pre>".$line."\n</pre>";
              return false;
            }
		}
        
	}
	
?>
